<?php
/////////////////////////////////////////////////////////
//	SORTING IMAGES PER DRAG 'N' DROP (ADMIN)    //
/////////////////////////////////////////////////////////

	// SET FOLDER ID
	$folderID = (empty($_REQUEST['fID']))? 1:(int)$_REQUEST['fID'];
	if (!$mg2->getFolderSettings($folderID)) {
		$mg2->displaystatus($mg2->lang['nofolderid'] .' #'. $folderID, 3);
		return false;
	}

	// GET IMAGE RECORDS
	$images = $mg2->select($folderID, $mg2->all_images, 1, $mg2->images_sortmode);

	// ONLY ONE IMAGE?
	if (($cimages = count($images)) < 2) {
		$mg2->displaystatus($mg2->lang['noimagestosort'], 1);
		return false;
	}

	// (RE)SET SORTING PARAMETERS
	$_SESSION[GALLERY_ID]['sortstart'] = true;	// sorting start true
	$_SESSION[GALLERY_ID]['sorting']   = false;	// sorting array empty

	// SORT TABLE HEAD
	if ($mg2->folder_position < 0) {
		$headStyle = sprintf('style="padding-top:12px;background-color:#FFCFCF;" title="%s (%s %d)"',
							 $mg2->lang['nodisplay'],
							 $mg2->lang['position'],
							 $mg2->folder_position
						 );
	}
	elseif ($mg2->folder_publish > time()) {
		$headStyle = sprintf('style="padding-top:12px;background-color:#FFFF99;" title="%s %s"',
							 $mg2->lang['notpublished'],
							 $mg2->time2date($mg2->folder_publish)
						 );
	}
	else {
		$headStyle = 'style="padding-top:12px;"';
	}
	$class		= 'table_files';
	$navigation = sprintf('%s: %s : %s&nbsp;%s',
							$mg2->lang['navigation'],
							$mg2->adminnavigation($folderID),
							count($images),
							$mg2->lang['images']
					  );
?>
<!-- GET JAVASCRIPT LIBRARIES -->
<script src="admin/sorting/prototype.js" type="text/javascript"></script>
<script src="admin/sorting/scriptaculous.js" type="text/javascript"></script>
<span id="ajaxresult"></span>
<form name="fileform" action="<?php echo ADMIN_INDEX;?>" method="post">
<input type="hidden" name="action" value="savesorting" />
<input type="hidden" name="editfolder" value="<?php echo $folderID;?>" />
<input type="hidden" name="page"	value="<?php echo $page;?>" />
<div class="sort_box">
	<div class="td_navigation" <?php echo $headStyle;?>>
<?php echo $navigation;
	// PASSWORD SET
	if (!empty($mg2->all_folders[$folderID][8]))
		printf('&nbsp;&nbsp;<img src="%simages/lock.gif" width="15" height="15" alt="%2$s" title="%2$s" style="vertical-align:text-bottom" />',
			ADMIN_FOLDER,
			$mg2->lang['thissection']
		);
?> 
	</div>
	<div class="td_actions_right" align="center">
<?php
	// CANCEL BUTTON
	printf('<a href="%s?editfolder=%d&amp;page=%s"><img src="%simages/cancel.gif" width="24" height="24" alt="%5$s" title="%5$s" class="adminpicbutton" /></a>'."\n",
		ADMIN_INDEX,
		$folderID,
		$page,
		ADMIN_FOLDER,
		$mg2->lang['cancel']
	);
	// OK BUTTON
	printf('<input type="image" src="%simages/ok.gif" alt="%2$s" title="%2$s" class="adminpicbutton" />'."\n",
		ADMIN_FOLDER,
		$mg2->lang['setpositions']
	);
?>
	</div>
	<div class="td_actions_right">
		<ul id="sortlist">

<?php
	// DISPLAY ALL THUMBNAILS OF FOLDER
	for ($i=0; $i < $cimages; $i++) {

		// GET IMAGE VALUES
		$imageID		  = $images[$i][0];
		$imagename	  = $images[$i][6];
		$thumb_width  = $images[$i][10];
		$thumb_height = $images[$i][11];
		$subdir		  = $images[$i][7];
		$imagefile	  = $mg2->get_path($imagename, $subdir);

		// GET THUMB FILE
		$thumbfile = $mg2->get_path($imagename, $subdir, 'thumb');
		if (!is_readable($thumbfile))
			$thumbfile = ADMIN_FOLDER .'images/1x1.gif';

		// THUMBNAIL DISPLAY TYPE
		if ($images[$i][5] < 0) {
			$class = 'red';
		}
		elseif ($images[$i][4] > time()) {
			$class = 'yellow';
		}
		else {
			$class = 'green';
		}
		// DISPLAY THUMBNAIL ITEM
		printf('<li id="item_%d" class="%s">
					 <img src="%s" width="%d" height="%d" alt="%6$s" title="%6$s" />
				  </li>
				 ',
				 $imageID,
				 $class,
				 $mg2->cleanURLString($thumbfile),
				 $thumb_width,
				 $thumb_height,
				 $imagefile
		);
	}

	// CREATE SORTING QUERY
	$sortquery = '&galleryid='. substr(GALLERY_ID, 3) .'&pwd='. $mg2->adminpwd;
?>
		</ul>
		<div style="clear:left">&nbsp;</div>
	</div>
	<script type="text/javascript">
	/* <![CDATA[ */
		Sortable.create
		(
			'sortlist',
			{
				constraint: false,
				overlap: 'horizontal',
				scroll: window,
				onUpdate: function()
				{
					new Ajax.Updater
					(
						'ajaxresult', 'admin/sorting/savesorting.php',
						{ postBody: Sortable.serialize('sortlist') + '<?php echo $sortquery;?>'}
					);
				}
			}
		);
	/* ]]> */
	</script>

	<!-- DISPLAY BUTTONS -->
	<div class="td_navigation" align="center">
<?php
	// CANCEL BUTTON
	printf('<a href="%s?editfolder=%d&amp;page=%s"><img src="%simages/cancel.gif" width="24" height="24" alt="%5$s" title="%5$s" class="adminpicbutton" /></a>'."\n",
		ADMIN_INDEX,
		$folderID,
		$page,
		ADMIN_FOLDER,
		$mg2->lang['cancel']
	);
	// OK BUTTON
	printf('<input type="image" src="%simages/ok.gif" alt="%2$s" title="%2$s" class="adminpicbutton" />'."\n",
		ADMIN_FOLDER,
		$mg2->lang['setpositions']
	);
?>
	</div>
</div>
</form>
