<?php
////////////////////////////////////////////////////////
//	DISPLAY FOLDER AND IMAGE TABLE (ADMIN)	//
////////////////////////////////////////////////////////

	// GET CURRENT PAGE AND IMAGE SUFFIX
	$isuffix = '';
	if (isset($_GET['rotate'])) {
		$mg2->getMemoryStatus();
		$imageID	= (int)$_GET['rotate'];
		$mg2->rotateImage($imageID);
		list($currentPage, $isuffix) = $mg2->editID($imageID, $updatedComment, $Calendar);
	}
	elseif (isset($_REQUEST['editID'])) {
		$imageID	= (int)$_REQUEST['editID'];
		list($currentPage, $isuffix) = $mg2->editID($imageID, $updatedComment, $Calendar);
	}
	else {
		$currentPage = $page;
	}

	// GET FOLDER ID
	$folderID = (empty($_REQUEST['fID']))? 1:max((int)$_REQUEST['fID'], 1);
	if (!$mg2->getFolderSettings($folderID)) {
		$mg2->displaystatus($mg2->lang['nofolderid'] .' #'. $folderID, 3);
		if ($folderID !== 1) {
			$folderID = 1;
			$mg2->getFolderSettings($folderID);
		}
	}

	// GET CONTAINED FOLDERS AND IMAGES
	$folders  = $mg2->select($folderID, $mg2->all_folders,1, $mg2->getFolderSortMode());// kh_mod 0.3.0, changed
	$images   = $mg2->select($folderID, $mg2->all_images, 1, $mg2->images_sortmode);		// kh_mod 0.3.0, changed
	$cfolders = count($folders);																			// kh_mod 0.1.0, add
	$cimages  = count($images);																			// kh_mod 0.1.0, add

	// GET COLS AND ROWS PER PAGE
	$imagecols = ((int)$mg2->all_folders[$folderID][9] < 1)?
					 $mg2->imagecols									// global setting
					 :
					 (int)$mg2->all_folders[$folderID][9];		// folder setting
	$imagerows = ((int)$mg2->all_folders[$folderID][10] < 1)?
					 $mg2->imagerows									// global setting
					 :
					 (int)$mg2->all_folders[$folderID][10];	// folder setting

	//CALCULATE ICONS PER PAGE AND NUMBER OF PAGES
	$numicons = max($imagecols * $imagerows, 1);				// number of thumbs and folder icons per page
	$numpages = max(ceil($cimages / $numicons), 1);			// number of pages

	// CALCULATE FIRST AND LAST INDEX OF PAGE
	if ($currentPage === 'all') {
		$first = 0;
		$last  = $cimages;
	}
	else {
		$currentPage = min($currentPage, $numpages);
		$first = $numicons * ($currentPage - 1);
		$last  = min($first + $numicons, $cimages);
	}

	// DISPLAY TABLE HEADER
	$tableHead = '';
	if ($mg2->folder_position < 0) {				// folder locked?
		$tableHead = ' bgcolor="#FFCFCF" title="'. $mg2->lang['nodisplay'];
		$tableHead.= ' ('. $mg2->lang['position'] .' '. $mg2->folder_position .')"';
	}
	elseif ($mg2->folder_publish > time()) {	// folder published not yet?
		$tableHead = ' bgcolor="#FFFF99" title="'. $mg2->lang['notpublished'];
		$tableHead.= ' '. $mg2->time2date($mg2->folder_publish) .'"';
	}
	$navigation = sprintf('%s: %s : %d&nbsp;%s%s',
							$mg2->lang['navigation'],
							$mg2->adminnavigation($folderID),
							count($images),
							$mg2->lang['images'],
							$mg2->adminpagenavigation($folderID, $numpages, $currentPage)
					  );
	include(ADMIN_FOLDER .'admin_table_start.php');

	//
	// COUNT PICTURES INCL. ALL SUBFOLDERS
	// kh_mod 0.3.2, add
	$subfolders = $mg2->getValidSubfolders($folderID);		// get all sub folders
	$n_pictures	= $mg2->countFolderPictures($subfolders);	// count all pictures

	//
	// LIST FOLDERS
	// kh_mod 0.3.1, changed
	for ($i=0; $i < $cfolders; $i++) {
		$folder_flag = (trim($folders[$i][8]) != '')? 1:0;
		$folder_flag|= ((int)$folders[$i][6] > 0)?	 2:0;
		// IS SET FOLDER PASSWORT AND FOLDER THUMBNAIL?
		if ($folder_flag === 3) {
			$small_icon = ADMIN_FOLDER .'images/folder_small_thumb_locked.gif';
		}
		// IS SET FOLDER PASSWORT?
		elseif ($folder_flag === 1) {
			$small_icon = ADMIN_FOLDER .'images/folder_small_locked.gif';
		}
		// IS SET FOLDER THUMBNAIL?
		elseif ($folder_flag === 2) {
			$small_icon = ADMIN_FOLDER .'images/folder_small_thumb.gif';
		}
		// STANDARD ICON
		else {
			$small_icon = ADMIN_FOLDER .'images/folder_small.gif';
		}

		// FOLDER TOOLTIP
		$folderThumb = '';
		if (($mg2->extendedset & 8)   &&            // displaying switched on?
			 ($thumbID = (int)$folders[$i][6]) > 0)  // is set folder thumbnail?
		{
			$thumbFilePath = $mg2->get_path($mg2->all_images[$thumbID][6], $mg2->all_images[$thumbID][7], 'thumb');
			if (is_readable($thumbFilePath))
			{
				$folderThumb = sprintf('&lt;img src=\\\'%s\\\' width=\\\'%d\\\' height=\\\'%d\\\' alt=\\\'\\\' /&gt;',
										$thumbFilePath,
										$mg2->all_images[$thumbID][10],
										$mg2->all_images[$thumbID][11]
									);
			}
		}

		// GET PUBLISH DATE AND TIME OF FOLDER
		$publishdate = $mg2->time2date($folders[$i][4], false);
		$publishtime = (empty($mg2->timeformat))?
							''
							:
							$mg2->time2date($folders[$i][4]);
		include(ADMIN_FOLDER .'admin3_folders.php');
	}

	//
	// LIST FILES
	// kh_mod 0.1.0, changed
	for ($i=$first; $i < $last; $i++) {
		// COUNTER START BY 0
		$num = $i-$first;

		// CALCULATE IMAGE SIZE
		$filesize = $mg2->convertBytes((int)$images[$i][12], 1);

		// GET IMAGE VALUES
		$imageID		  = $images[$i][0];
		$imagename	  = $images[$i][6];
		$subdir		  = $images[$i][7];
		$imagenameURL = rawurlencode($imagename);
		$thumb_width  = $images[$i][10];
		$thumb_height = $images[$i][11];
		$imagefile	  = $mg2->get_path($imagename, $subdir);

		// GET THUMB FILE
		$thumbfile = $mg2->get_path($imagename, $subdir, 'thumb');
		$thumbfile = ($thumb_ok = is_readable($thumbfile))?
						 $mg2->get_path($imagenameURL, $subdir, 'thumb')
						 :
						 ADMIN_FOLDER .'images/1x1.gif';
		$thumbfile.= $isuffix;		// image suffix

		// CALCULATE MINITHUMB SIZE
		$minithumb_width  = max((int)round($thumb_width/5) , 5);
		$minithumb_heigth = max((int)round($thumb_height/5), 5);

		// GET PUBLISH DATE AND TIME OF FILE
		$publishdate = $mg2->time2date($images[$i][4], false);
		$publishtime = (empty($mg2->timeformat))?
							''
							:
							$mg2->time2date($images[$i][4]);

		// GET THUMB TOOLTIP
		$thumb_info = '';
		if (($mg2->extendedset & 8) && $thumb_ok) {
			$thumbImage = '&lt;img src=\\\'%s\\\' width=\\\'%d\\\' height=\\\'%d\\\' alt=\\\'\\\' /&gt;';
			$thumbTitle = '';
			if (include_once(INC_FOLDER .'mg2_exif.php')) {
				$exif_data = array();		// init resp. reset exif_data, kh_mod 0.1.0 b3, add
				exif($imagefile);				// get exif-date
				$exif_date = (isset($exif_data['DTOpticalCapture']))?
								  $mg2->exif2date($exif_data['DTOpticalCapture'])
								  :
								  '&ndash;';
				$thumbTitle = '&lt;div style=\\\'white-space:nowrap;\\\'&gt;ID: #%d,&nbsp;Exif-%s: ';
				$thumbTitle.= (strlen($exif_date) > 7)?
								  '&lt;/div&gt;&lt;div style=\\\'white-space:nowrap;\\\'&gt;'
								  :
								  '&nbsp;';
				$thumbTitle.= '%s&lt;/div&gt;';
			}
			$thumb_info = sprintf($thumbImage . $thumbTitle,
									$thumbfile,
									$thumb_width,
									$thumb_height,
									$imageID,
									$mg2->lang['date'],
									$exif_date
							  );
		}

		// GET COMMENT FILE
		$commfile	= $mg2->get_path($imagename, $subdir, 'comment');
		$ncomments	= $mg2->readcomments($commfile);
		$ndisplayed	= 0;
		foreach ($mg2->comments as $comment) {
			if ((int)$comment[7] === 1) $ndisplayed++;
		}
		$comminfo = $ndisplayed .'/'. $ncomments;
		include(ADMIN_FOLDER .'admin3_files.php');
	}

	// DISPLAY CONTROLS
	if ($selectsize = $last - $first) {
		if (empty($mg2->sortedfolders)) $mg2->makeFolderlist();
		include(ADMIN_FOLDER .'admin4_controls.php');
	}
	else {
		echo "\n</table>\n</form>";
	}
?>
